package td;

/**
 * Notre cellule lmentaire est compose d'une rfrence vers une autre cellule et d'une valeur.
 * @author jub
 * @param <X> Le type du contenu de la cellule.
 */
public class Cellule<X> {
	/**
	 * La valeur stoque dans la cellule
	 */
	private X valeur;
	/**
	 * La rfrence vers la cellule suivante
	 */
	private Cellule<X> suivant;

	/**
	 * Initialement la cellule n'a pas de valeur et pas de cellule suivante
	 */
	public Cellule()
	{
		this.valeur = null;
		this.suivant = null;
	}

	/**
	 * @return vrai si la cellule est vide, faux sinon.
	 */
	public boolean estVide()
	{
		return this.valeur == null;
	}

	/**
	 * @return la rfrence vers une autre cellule du mme type
	 */
	public Cellule<X> getSuivant() {
		return suivant;
	}

	/**
	 * @return la valeur de la cellule
	 */
	public X getValeur() {
		return valeur;
	}
	
	/**
	 * @param suivant la rfrence vers la cellule suivante, pas forcement du mme type
	 */
	public void setSuivant(Cellule suivant) {
		this.suivant = suivant;
	}
	
	/**
	 * @param valeur la valeur de la cellule
	 */
	public void setValeur(X valeur) {
		this.valeur = valeur;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		String s;
		if (this.valeur!=null)
			
				s = "(" + this.valeur.toString()+")->";
		else
				s="X->";
		
		if (this.suivant != null)
				s = s + this.suivant.toString();
				else
					s = s +"|";
		
		return s;
	}
	
}
