package td;

/**
 * Un Cercle est caractris par son centre un Point et par un rayon
 * @author jub
 */
public class Cercle {
	/**
	 * Le centre un Point
	 */
	private Point centre;

	/**
	 * Le rayon
	 */
	private int rayon;
	/**
	 * Construit un cercle de centre (0,0) et de rayon 1
	 * this( ) permet de faire appel  l'un de ses autres constructeurs
	 */
	public Cercle()
	{
		this(new Point(0,0),1);
	}
	
	/**
	 * Construit un cercle de centre (x,y) et de rayon rayon
	 * @param x l'abscisse du centre du cercle
	 * @param y l'ordonne du centre du cercle
	 * @param rayon le rayon du cercle
	 */
	public Cercle(int x, int y, int rayon)
	{
		this(new Point(x,y),rayon);
	}
	
	/**
	 *  Construit un cercle clone d'un autre
	 * @param cercle le cercle qui est recopi
	 */
	public Cercle(Cercle cercle)
	{
		this(new Point(cercle.getCentre()), cercle.getRayon());
	}
	
	/**
	 * Ce constructeur est celui qui est appel par tous les autres, ce n'est pas obligatoire mais c'est un choix de conception.
	 * @param centre le centre du cercle
	 * @param rayon le rayon du cercle
	 */
	public Cercle(Point centre, int rayon) {
		this.centre = new Point(centre);
		this.rayon = rayon;
	}
	
	/**
	 * @return la circonfrence du cercle (2*PI*rayon)
	 */
	public double circonference()
	{
		double res;
		res = Math.PI * 2 * this.rayon;
		return res;
	}

	/**
	 * Dplace le cercle en (x,y)
	 * @param x l'abscisse de destination
	 * @param y l'ordonne de destination
	 */
	public void deplacer(int x, int y)
	{
		this.centre.deplacer(x, y);
	}

	/**
	 * @return le centre du cercle 
	 */
	public Point getCentre() {
		return centre;
	}

	/**
	 * @return le rayon du cercle
	 */
	public int getRayon() {
		return rayon;
	}

	/**
	 * @param centre le centre du cercle
	 */
	public void setCentre(Point centre) {
		this.centre = centre;
	}

	/**
	 * @param rayon le rayon du cercle
	 */
	public void setRayon(int rayon) {
		this.rayon = rayon;
	}
	
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return "("+this.centre.getX()+","+this.centre.getY()+") de rayon "+this.rayon;
	}

		
}
