/**
 * 
 */
package tp.prof.classes;

/**
 * @author jub
 *Classe d'un point 2D
 */

public class Point implements Comparable<Point>{

/**
 * x: abscisse
 * y: ordonne
 */

private int x,y;

/**
 * Permet de crer un point de coordonnes (x,y)
 * @param x l'abscisse
 * @param y l'ordonne
 */
public Point(int x, int y) {
	this.x = x;
	this.y = y;
}

/**
 * Permet de crer un point de coordonnes (0,0)
 */
public Point() {
	this(0,0);
}

/**
 * Permet de crer un point de mmes coordonnes qu'un autre point
 * @param point 
 */
public Point(Point point) {
	this(point.getX(),point.getY());
}

/**
 * Renvoie l'abscisse
 * @return the x
 */
public int getX() {
	return x;
}

/**
 * Dfinit l'abscisse
 * @param x the x to set
 */
public void setX(int x) {
	this.x = x;
}

/**
 * Renvoie l'ordonne
 * @return the y
 */
public int getY() {
	return y;
}

/**
 * Dfinie l'ordonne
 * @param y the y to set
 */
public void setY(int y) {
	this.y = y;
}



/**
 * translate le point courant de dx et dy (i.e les nouvelles coordonnes de mon Point sont (x+dx,y+dy) )
 * @param dx un int
 * @param dy un int
 */
public void translater(int dx,
                       int dy)
{
	this.setX(this.getX()+dx);  
	this.setY(this.getY()+dy);
}
    

/**
 * dplace le point courant en (newX,newY)(i.e les nouvelles coordonnes de mon Point sont (newX,newY) )
 * @param x un int
 * @param y un int
 */
public void deplacer(int x,
                     int y)

{
	this.setX(x);
	this.setY(y);
}
   

/**
 * renvoie la distance  l'origine du Point courant
 * @return distance  l'origine
 */
public double distanceOrigine()
{
 return this.distance(new Point(0,0));
}

/**
 * Renvoie la distance entre deux points
 * @param autrePt
 * @return distance
 */
public double distance(Point autrePt)
{
	double dx,dy;
	dx=this.getX()-autrePt.getX();
	dy=this.getY()-autrePt.getY();
	
	double res;
	res= Math.sqrt(Math.pow(dx, 2)+ Math.pow(dy,2));
	return res;
}
    

/* (non-Javadoc)
 * @see java.lang.Object#toString()
 */
public String toString()
{
	String s="("+this.getX()+","+this.getY()+")";
	return s;
}

@Override
public int compareTo(Point arg0) {
	if (this.distanceOrigine() < arg0.distanceOrigine())
		return -1;
	else 
		if (this.distanceOrigine() == arg0.distanceOrigine())
			return 0;
		else
			return 1;
}    

}

